// Keygen for: MISSION #2 Vacation In Hell! v2.01 by Chris Spry, 1995
// Keygen by: akacastor 2024-03-29, AP Class


#include <stdio.h>
#include <string.h>


int main(int argc, char **argv)
{
#define MAX_SYSOP_NAME_LEN      32
    char sysop_name[MAX_SYSOP_NAME_LEN+1] = "";
    int sysop_name_len;
    int i;
    int keyval;

    
    printf( "Keygen for Mission #2.\n" );
    printf( "by akacastor 2024-03-29, an AP Class release.\n\n" );

    if( argc < 2 )
    {
        printf( "usage: %s <SysOp Name>\n", argv[0] );
        return 1;
    }

    // if sysop name is multiple words, concatenate it into sysop_name
    for( i=1; i<argc && strlen(sysop_name) < (MAX_SYSOP_NAME_LEN - 1); i++ )
    {
        if( strlen(sysop_name) )    // put a space between words passed on the command line
            strncat( sysop_name+strlen(sysop_name), " ", MAX_SYSOP_NAME_LEN - strlen(sysop_name) );        
        strncat( sysop_name+strlen(sysop_name), argv[i], MAX_SYSOP_NAME_LEN - strlen(sysop_name) );
    }
    
    sysop_name_len = strlen(sysop_name);
    for( i=sysop_name_len; i<6; i++ )
    {   // pad sysop_name to be at least 6 characters long before generating key
        sysop_name[i] = ' ';
        sysop_name[i+1] = '\0';
    }
    
    printf( "SysOp Name: \"%s\"\n", sysop_name );
    
    printf( "Reg. Code:  " );
    for( i=0; i<6; i++ )
    {
        keyval = sysop_name[i];
        keyval *= 2;
        keyval -= 1;
        
        printf( "%d%c", keyval, i<5 ? '-' : 'A' );
    }
    
    printf( "\n" );
    
    
    if( sysop_name_len < 6 )
        printf( "\nNote - restart M2CONFIG after entering SysOp Name, before entering Reg Code!\n" );
    
    
    return 0;
}
